<template>
  <single-pane :capt="$options.dictionary.title" ref="singlePane">
    <div class="h-100">
      <ob-table
        :items="formDataArray"
        :columns="columnsObTable"
        :functionalPanel="true"
        @select="$refs.popup.open()"
        :tableLayoutFixed="false"
        ref="obTable"
      >
        <template v-slot:comment="{ data }">
          <i class="icon edit"></i>
        </template>
      </ob-table>
      <ObModal title="Настройка категорий" ref="popup">
        <price-popup
          @changed="changeHandler"
          @close="$refs.popup.close()"
          :data-source="costOptions"
        />
      </ObModal>
    </div>
  </single-pane>
</template>

<script>
import api from "@/api";
import SinglePane from "common-components/src/obComponents/obSinglePanels";
import ObTable from "common-components/src/obComponents/obTable";
import tableLayoutMixin from "../../mixins/table-layout-mixin";
import ObModal from "common-components/src/obComponents/obModal";
import PricePopup from "./modal/popup";
import { dictionary } from '@/translations/ru/settings__morz__price_categories'


export default {
  components: {
    ObTable,
    PricePopup,
    ObModal,
    SinglePane
  },
  mixins: [
    tableLayoutMixin
  ],
  dictionary,
  data() {
    return {
      propertyId: "uuid",
      selectedRowData: {},
      rules: {},
      editTitle: "",
      index: 0,
      formDataArray: [],
      costOptions: null,
      ndash: "&nbsp;&ndash;&nbsp;"
    };
  },

  created() {
    this.fetch();
  },

  methods: {
    async fetch() {
      try {
        const res = await api.cargo.getCargoCostOptions();
        this.costOptions = res.data;
        this.formDataArray = [
          {
            cargo_value: "Высокая",
            corridor: `> ${Intl.NumberFormat('ru-RU').format(this.costOptions.highMinCost / 100)}${
                    Intl.NumberFormat('ru-RU').format(this.costOptions.absoluteMaxCost)
                            ? this.ndash + Intl.NumberFormat('ru-RU').format(this.costOptions.absoluteMaxCost / 100)
                            : ""
                    }`,
            date: this.getDate(this.costOptions.updatedDate)
          },
          {
            cargo_value: "Средняя",
            corridor: `${Intl.NumberFormat('ru-RU').format(this.costOptions.mediumMinCost / 100)}${this.ndash}${Intl.NumberFormat('ru-RU').format(this.costOptions.highMinCost / 100)}`,
            date: this.getDate(this.costOptions.updatedDate)
          },
          {
            cargo_value: "Низкая",
            corridor: `< ${Intl.NumberFormat('ru-RU').format(this.costOptions.mediumMinCost / 100)}`,
            date: this.getDate(this.costOptions.updatedDate)
          }
        ];
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },

    getDate(date) {
      const temp = new Date(date);
      const day = temp.getDate();
      let month = temp.getMonth();
      if (month < 9) {
        month = `0${month + 1}`;
      } else {
        month += 1;
      }
      const year = temp.getFullYear();
      return `${day}.${month}.${year}`;
    },

    changeHandler(data) {
      let notificationId = new Date().getTime()+'save';
      this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
      const newData = { ...data, updatedDate: new Date() };
      api.cargo
        .setCargoCostOptions(newData)
        .then(() => {
          this.fetch();
          this.$notification({
            type: 'system_notification_success',
            message: 'Сохранено'
          })
        }).catch((e)=>{
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
      }).finally(()=>{
        this.$notification({event: 'close', id: notificationId})
      });
    }
  },

  computed: {
    columnsObTable() {
      return [
        {
          title: dictionary.columns.cargo_value,
          key: "cargo_value"
        },
        {
          title: dictionary.columns.corridor,
          key: "corridor"
        },
        {
          title: dictionary.columns.date,
          key: "date"
        },
        {
          title: "",
          key: "comment",
          slotName: "comment"
        }
      ];
    }
  }
};
</script>

<style lang="scss" scoped>
.dx-datagrid-action {
  width: 300px !important;
}

::v-deep {
  .edit {
    opacity: 0;
  }

  tr:hover .edit {
    opacity: 1;
  }
}
</style>
